/* globals */

var VCwebphone;
var Initialized;
var Connected;
var currSession;

var UserCredentials='1';// toon settings-knop en laat gebruiker creentials invullen

var VCconfig = {
  // sipaccount@sipserver (vb sip123@11.22.33.44)
  uri: 'testacc7700702@89.31.96.29',
  //uri: 'voipcenter8@89.31.96.29',
  // wss://sipserver:9123/ws (vb wss://11.22.33.44:9123/ws)
  wsServers: 'wss://89.31.96.29:9123/ws',
  // VoipCenter SIPaccount username (vb sip123)
  authorizationUser: 'testacc7700702',
  //authorizationUser: 'voipcenter8',
  // VoipCenter SIPaccount paswoord (vb 987654)
  password: '5N2hFkdKWR',
  //password: '0gAqMGOB',
  // Extra parameters
  hackIpInContact: true,
  hackWssInTransport: true,
  // stun servers
  stunServers: "stun:stun.ekiga.net",
  // meteen SIP-registratie bij start van VoipCenter webphone ?
  // default : false (dus VCwebphone.start(VCconfig,true) of VCwebphone.register() noodzakelijk)
  register: false
};

$(document).ready(function() {
    
    $("#oncall_incoming").hide();
    $("#oncall_outgoing").hide();
    $("#oncall").hide();
    
    // Auto-focus number input on backspace.
    $('#sipClient').keydown(function(event) {
        if (event.which === 8) {
            $('#numDisplay').focus();
        }
    });
    
    $('#phoneUI .dropdown-menu').click(function(e) {
        e.preventDefault();
    });
    
    // bij click op dialpad button & volumeknop
    $('.dropdown-toggle').on('click', function() {
        
        if (Initialized!==1 || Connected!==1) {
            VCwebphone.setError(true, 'Geen connectie', 'Webphone niet geconnecteerd met de VoipCenter software.');
            return false;
        }
        
    });
        
    $('.digit').click(function(event) {
        
        event.preventDefault();
        var num = $('#numDisplay').val(),
            dig = $(this).data('digit');

        $('#numDisplay').val(num+dig);
        if (currSession!=='' && currSession!==undefined) {
            // DTMF tijdens gesprek
            console.log("sipSendDTMF:"+dig);
            VCwebphone.sipSendDTMF(dig);
        }
        return false;
        
    });
    
    $('#b_connection').click(function(event) {
        
        event.preventDefault();

        if (Connected===1) {
            VCwebphone.Stop();
            VCwebphone.setConnectionState('disconnected');
        } else {
            VCwebphone.Start(VCconfig,true);
            VCwebphone.setConnectionState('connected');
        }
        
        return false;
        
    });
    
    
});


// begin VCwebphone object definitie
VCwebphone = {

    ringtone     : $('#ringtone'),
    ringbacktone : document.getElementById('ringbacktone'),
    dtmfTone     : document.getElementById('dtmfTone'),

    Stream       : null,
    phone           : null,

    /**
     * Parses a SIP uri and returns a formatted E164 phone number.
     *
     * @param  {string} phone number or uri to format
     * @return {string} formatted number
     */
    /*
    formatPhone : function(phone) {

        var num;

        if (phone.indexOf('@')) {
            num =  phone.split('@')[0];
        } else {
            num = phone;
        }

        num = num.toString().replace(/[^0-9]/g, '');

        if (num.length === 10) {
            return '(' + num.substr(0, 3) + ') ' + num.substr(3, 3) + '-' + num.substr(6,4);
        } else if (num.length === 11) {
            return '(' + num.substr(1, 3) + ') ' + num.substr(4, 3) + '-' + num.substr(7,4);
        } else {
            return num;
        }
    },*/
    
    Initialize : function() {

        Initialized=1;
    
        /* Tests for a capable browser, return bool, and shows an error modal on fail. */
        if (navigator.webkitGetUserMedia) {
            //
        } else if (navigator.mozGetUserMedia) {
            //
        } else if (navigator.getUserMedia) {
            //
        } else {
            VCwebphone.setError(true, 'Unsupported Browser.', 'Your browser does not support the features required for this phone.');
            window.console.error("WebRTC support not found");
            Initialized=0;
        }
        
        if (Initialized===1) {
            VCwebphone.setStatus("Initialized");
            console.log("Initialized!");
            return true;
        } else {
            VCwebphone.setStatus("No browser support");
            console.log("No browser support!");
            return false;
        }
        
    },

    // Sound methods
    startRingTone : function() {
        try { VCwebphone.ringtone.play(); } catch (e) { }
    },

    stopRingTone : function() {
        try { VCwebphone.ringtone.pause(); } catch (e) { }
    },

    startRingbackTone : function() {
        try { VCwebphone.ringbacktone.play(); } catch (e) { }
    },

    stopRingbackTone : function() {
        try { VCwebphone.ringbacktone.pause(); } catch (e) { }
    },

    newSession : function(newSess) {

        newSess.displayName = newSess.remoteIdentity;

        var status;

        if (newSess.direction === 'incoming') {
            console.log("incoming session");
            status = "Incoming: "+ newSess.displayName;
            VCwebphone.startRingTone();
        } else {// outgoing
            console.log("Outgoing session");
            status = "Trying: "+ newSess.displayName;
            VCwebphone.startRingbackTone();
        }
        
        currSession=newSess;// nieuwe sessie is een feit
        VCwebphone.setCallSessionStatus(status);
        
        // EVENT CALLBACKS

        newSess.on('progress',function(e) {
            console.log("progress");
            if (e.direction === 'outgoing') {
                VCwebphone.setCallSessionStatus('Calling...');
            }
        });

        newSess.on('connecting',function(e) {
            if (e.direction === 'outgoing') {
                VCwebphone.setCallSessionStatus('Connecting...');
            }
        });

        newSess.on('accepted',function(e) {

            console.log("accepted");

            VCwebphone.stopRingbackTone();
            VCwebphone.stopRingTone();
            VCwebphone.setCallSessionStatus('Answered');
            $("#oncall_outgoing").hide();
            $("#oncall_incoming").hide();
            $("#oncall").show();

        });

        newSess.on('cancel', function(e) {
            console.log("Cancelled");
            VCwebphone.stopRingTone();
            VCwebphone.stopRingbackTone();
            VCwebphone.setCallSessionStatus("Canceled");
            if (this.direction === 'outgoing') {
                newSess = null;
                currSession='';
            }
            $("#oncall_incoming").hide();
        });

        newSess.on('bye', function(e) {
            console.log("received bye");
            VCwebphone.stopRingTone();
            VCwebphone.stopRingbackTone();
            VCwebphone.setCallSessionStatus("");
            currSession='';
            $("#numDisplay").val("");
            $("#oncall").hide();
        });

        /*newSess.on('failed',function(e) {
            VCwebphone.stopRingTone();
            VCwebphone.stopRingbackTone();
            VCwebphone.setCallSessionStatus('Terminated');
            $("#oncall").hide();
        });*/

        newSess.on('rejected',function(e) {
            console.log("received rejected");
            VCwebphone.stopRingTone();
            VCwebphone.stopRingbackTone();
            VCwebphone.setCallSessionStatus('Rejected');
            //VCwebphone.callActiveID = null;
            //newSess = null;
            currSession='';
            $("#oncall_incoming").hide();
            $("#oncall_outgoing").hide();
        });


    },
    
    newVCsip : function(registration) {
        
        var SIPuser=$("#sipuser").val();
        var SIPpasswd=$("#sippasswd").val();
        
        if (UserCredentials==='1') {
            if (SIPuser==='' || SIPpasswd==='') {
                VCwebphone.setError(true, 'No connection.', 'Authenticatie gegevens incorrect.');
                console.log("Authenticatie gegevens incorrect.");
            } else {
                VCconfig.uri=SIPuser+'@89.31.96.29';
                VCconfig.authorizationUser=SIPuser;
                VCconfig.password=SIPpasswd;
                
                // new VCwebphone
                VCwebphone.phone = new SIP.UA(VCconfig);
            }
        } else {
            // new VCwebphone
            VCwebphone.phone = new SIP.UA(VCconfig);
        }

        VCwebphone.phone.on('connecting', function(e) {
            VCwebphone.setStatus("Connecting");
        });

        VCwebphone.phone.on('connected', function(e) {
            VCwebphone.setStatus("Connected");
            VCwebphone.setConnectionState('connected');
            Connected=1;
        });

        VCwebphone.phone.on('disconnected', function(e) {

            VCwebphone.setStatus("Disconnected");
            VCwebphone.setConnectionState('disconnected');
            // disable phone
            VCwebphone.setError(true, 'Websocket Disconnected.', 'An Error occurred connecting to the websocket.');

            currSession='';
            Connected=0;

        });

        if (registration) {
            VCwebphone.phone.register();
        }

        VCwebphone.phone.on('registered', function(e) {

            $("#mldError").modal('hide');
            VCwebphone.setStatus("Registered");

            // Get the userMedia and cache the stream
            if (SIP.WebRTC.isSupported()) {
                SIP.WebRTC.getUserMedia({ audio : true, video : false }, VCwebphone.getUserMediaSuccess, VCwebphone.getUserMediaFailure);
            }
            $('#numDisplay').prop('disabled', false);

        });

        VCwebphone.phone.on('registrationFailed', function(e) {
            VCwebphone.setError(true, 'Registration Error.', 'An Error occurred registering your phone. Check your settings.');
            VCwebphone.setStatus("Error: Registration Failed");
        });

        VCwebphone.phone.on('unregistered', function(e) {
            
            $("#oncall").hide();
            VCwebphone.setStatus("Unregistered");
            $('#numDisplay').prop('disabled', true);
            $('.dropdown-toggle').on('click', function() {
                // bij click op dialpad button
                if (Initialized!==1) {
                    VCwebphone.setError(true, 'Geen connectie', 'Webphone niet geconnecteerd met de VoipCenter software.');
                    return false;
                }
            });
        });

        VCwebphone.phone.on('invite', function (incomingSession) {

            var s = incomingSession;
            s.direction = 'incoming';
            VCwebphone.newSession(s);
            console.log("incoming call");
            $("#oncall_incoming").show();
        });

        VCwebphone.phone.on('message', function (message) {
            console.log(message.body);
        });

        //
        $('#numDisplay').keypress(function(e) {
            // Enter pressed? so Dial.
            if (e.which === 13) {
                VCwebphone.phoneCallButtonPressed();
            }
        });

        $('#phoneUI').delegate('.btnCall', 'click', function(event) {
            VCwebphone.phoneCallButtonPressed();
            // to close the dropdown
            return true;
        });
        //
        
        // volumeknop
        $('#sldVolume').on('change', function() {

            var v = $(this).val() / 100,
                // player = $('audio').get()[0],
                btn    = $('#btnVol'),
                icon   = $('#btnVol').find('i');

            // Set the others
            $('audio').each(function() {
                $(this).get()[0].volume = v;
            });

            if (v < 0.1) {
                btn.removeClass(function (index, css) {
                       return (css.match (/(^|\s)btn\S+/g) || []).join(' ');
                    })
                    .addClass('btn btn-sm btn-danger');
                icon.removeClass().addClass('fa fa-fw fa-volume-off');
            } else if (v < 0.8) {
                btn.removeClass(function (index, css) {
                       return (css.match (/(^|\s)btn\S+/g) || []).join(' ');
                   }).addClass('btn btn-sm btn-info');
                icon.removeClass().addClass('fa fa-fw fa-volume-down');
            } else {
                btn.removeClass(function (index, css) {
                       return (css.match (/(^|\s)btn\S+/g) || []).join(' ');
                   }).addClass('btn btn-sm btn-primary');
                icon.removeClass().addClass('fa fa-fw fa-volume-up');
            }
            return false;
        });
        
        // buttons
        $('#b_answer').on('click', function() {
            VCwebphone.AcceptCall();
        });
        $('#b_bye').on('click', function() {
            VCwebphone.EndCall();
        });
        $('#b_reject').on('click', function() {
            VCwebphone.RejectCall();
        });
        $('#b_cancel').on('click', function() {
            VCwebphone.CancelCall();
        });
        
        return VCwebphone.phone;
        
    },
    
    Start : function(registration) {
        if(VCwebphone.Initialize()) {
            VCwebphone.newVCsip(registration);
        }
    },
    
    Stop : function() {
        VCwebphone.phone.stop();
        console.log("Unregister and close socket.");
    },
    
    Register : function() {
        VCwebphone.phone.register();
        VCwebphone.setStatus("Registered");
        console.log("Registered!");
    },
    
    Unregister : function() {
        VCwebphone.phone.unregister();
        VCwebphone.setStatus("Unregistered");
        console.log("Unregistered!");
    },

    // getUser media request refused or device was not present
    getUserMediaFailure : function(e) {
        window.console.error('getUserMedia failed:', e);
        VCwebphone.setError(true, 'Media Error.', 'You must allow access to your microphone.  Check the address bar.', true);
    },

    getUserMediaSuccess : function(stream) {
         VCwebphone.Stream = stream;
    },

    sipCall : function(phoneNumber) {

        try {
            var s = VCwebphone.phone.invite(phoneNumber, {
                media : {
                    stream      : VCwebphone.Stream,
                    constraints : { audio : true, video : false },
                    render      : { remote : $('#audioRemote').get()[0] }//,
                    // RTCConstraints : { "optional": [{ 'DtlsSrtpKeyAgreement': 'true'} ]}
                }
            });
            s.direction = 'outgoing';
            VCwebphone.newSession(s);
            $("#oncall_outgoing").show();

        } catch(e) {
            throw(e);
        }
    },

    sipSendDTMF : function(digit) {

        console.log("send dtmf "+digit);
        try { VCwebphone.dtmfTone.play(); } catch(e) { }
        currSession.dtmf(digit);

        /*var a = VCwebphone.callActiveID;
        if (a) {
            var s = VCwebphone.Sessions[a];
            s.dtmf(digit);
        }*/
    },

    phoneCallButtonPressed : function(sessionid) {

        //var s = VCwebphone.Sessions[sessionid],
        var s = currSession;
        var phoneNumber = $("#numDisplay").val();
        console.log("outgoing call");

        $("#numDisplay").val("");
        VCwebphone.sipCall(phoneNumber);

    },
    
    /*
     * sets the ui call status field
     * @param {string} status
     */
    setCallSessionStatus : function(status) {
        $('#txtCallStatus').html(status);
    },

    /*
     * sets the ui connection status field
     *
     * @param {string} status
     */
    setStatus : function(status) {
        $("#txtRegStatus").html('<i class="fa fa-signal"></i> '+status);
    },
    
    setError : function(err, title, msg, closable) {

        // Show modal if err = true
        if (err === true) {
            $("#mdlError p").html(msg);
            $("#mdlError").modal('show');

            //if (closable) {
                $("#mdlError .modal-header").find('button').remove();
                var b = '<button type="button" class="close" data-dismiss="modal">&times;</button>';
                $("#mdlError .modal-header").prepend(b);
                $("#mdlError .modal-title").html(title);
                $("#mdlError").modal({ keyboard : true });
            /*} else {
                $("#mdlError .modal-header").find('button').remove();
                $("#mdlError .modal-title").html(title);
                $("#mdlError").modal({ keyboard : false });
            }*/
            $('#numDisplay').prop('disabled', true);
        } else {
            $('#numDisplay').prop('disabled', false);
            $("#mdlError").modal('hide');
        }
    },
    
    setConnectionState : function(status) {
        $('#b_connection').attr('src', 'images/'+status+'.png');
        if (status==='connected') {
            Connected=1;
        } else {
            Connected=0;
        }
    },
    
    // accept incoming call
    AcceptCall : function() {
        
        currSession.accept({
            media: {
                render: {
                    remote: document.getElementById('audioRemote')
                }
            }
        });
    },
    
    // reject incoming call
    RejectCall : function() {
        currSession.reject();
    },
    
    // terminate ongoing call
    EndCall : function() {
        currSession.bye();
    },
    
    // cancel outgoing call
    CancelCall : function() {
        currSession.cancel();
    }

}
// einde VCwebphone definitie
